"""
Programme de création de niveau pour A Switch to the top fait par Tituya
Pour le CPC#26

0-> Air
1-> Mur solide
2-> Tue si contact
3-> Bloc chrono, disparait au bout d'un certain temps
4-> Bloc qui apparait au bout d'un certain temps
5-> Clef pour faire disparaite le bloc 6 (max 1/niveau)
6-> Bloc solide qui disparait avec la clef 5 (max 1/niveau)
8-> Fin (max 1/niveau)
9-> Début (max 1/niveau)
10-> Clef pour faire apparaitre les blocs 11 (max 1/niveau)
11-> Aparaissent avec la clef 10
"""

import pygame
from pygame.locals import *

grille=\
["1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1"],\
["1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","1"],\
["1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","1"],\
["1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","1"],\
["1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","1"],\
["1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","1"],\
["1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","1"],\
["1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1"]

#Defini la suite des blocs pendant les changements (cliquer sur un 1 va donner un 2, cliquer sur un 11 un 0...)
suite=["0","1","2","9","8","3","4","5","6","10","11"]
print("a")

def place():
    for a in range(8):
        for b in range(21):
            if grille[a][b]=="0":
                pygame.draw.rect(fenetre,(255,255,255),((52*b, 52*a), (52, 52)))
            if grille[a][b]=="1":
                pygame.draw.rect(fenetre,(0,0,0),((52*b, 52*a), (45, 45)))
            if grille[a][b]=="9":
                pygame.draw.circle(fenetre,(0,255,255),((52*b+22, 52*a+22)), 22)
                text=font.render("9",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="8":
                pygame.draw.rect(fenetre,(25,195,32),((52*b, 52*a), (45, 45)))
                text=font.render("8",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="2":
                pygame.draw.rect(fenetre,(255,50,50),((52*b, 52*a), (45, 45)))
                text=font.render("2",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="3":
                pygame.draw.rect(fenetre,(255,230,0),((52*b, 52*a), (45, 45)))
                text=font.render("3",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="4":
                pygame.draw.rect(fenetre,(0,0,230),((52*b, 52*a), (45, 45)))
                text=font.render("4",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="5":
                pygame.draw.polygon(fenetre,(255,230,100),[(52*b+23, 52*a+47), (52*b+47, 52*a+21), (52*b+22, 52*a-5), (52*b-3, 52*a+20)])
                text=font.render("5",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="6":
                pygame.draw.rect(fenetre,(255,230,100),((52*b, 52*a), (45, 45)))
                text=font.render("6",1,(0,0,0))
                fenetre.blit(text,(52*b+16,52*a+8))
            if grille[a][b]=="11":
                pygame.draw.rect(fenetre,(120,150,0),((52*b, 52*a), (45, 45)))
                text=font.render("11",1,(0,0,0))
                fenetre.blit(text,(52*b+11,52*a+8))
            if grille[a][b]=="10":
                pygame.draw.polygon(fenetre,(120,180,0),[(52*b+23, 52*a+47), (52*b+47, 52*a+21), (52*b+22, 52*a-5), (52*b-3, 52*a+20)])
                text=font.render("10",1,(0,0,0))
                fenetre.blit(text,(52*b+11,52*a+8))
    pygame.display.flip()

pygame.init()
pygame.display.set_caption('AST3 generator (Tituya)')
fenetre = pygame.display.set_mode((1092, 416))
font = pygame.font.SysFont('arial',25,True)
for a in range(8):
    for b in range(21):
        pygame.draw.rect(fenetre,(255,255,255),((52*b, 52*a), (52, 52)))
place()
securite=False
while securite==False:
    #boucle permettant l'affichage
    for event in pygame.event.get():
        if event.type==QUIT:
            securite=True
        elif event.type == pygame.MOUSEBUTTONDOWN:
            if event.button == 1:
                x=int(event.pos[0]/52)
                y=int(event.pos[1]/52)
                for i in range(len(suite)):
                    if grille[y][x] == suite[i]:
                        if i!=len(suite)-1:
                            grille[y][x]=suite[i+1]
                            break
                        else:
                            grille[y][x]=suite[0]
                            break
                pygame.draw.rect(fenetre,(255,255,255),((52*x, 52*y), (52, 52)))
                place()
            if event.button == 2:
                if "11" in str(grille) and not "10" in str(grille):
                    print("Il manque une clef 10 pour les blocs 11\n")
                elif "10" in str(grille) and not "11" in str(grille):
                    print("Clef 10 sans bloc 11 pour elle\n")
                elif "5" in str(grille) and not "6" in str(grille):
                    print("Clef 5 sans bloc 6 pour elle\n")
                elif "6" in str(grille) and not "5" in str(grille):
                    print("Il manque une clef 5 pour le bloc 6\n")
                elif str(grille).count("6")>1:
                    print("Trop de bloc 6 (limité à 1/niveau)\n")
                elif str(grille).count("10")>1:
                    print("Trop de clef 10 (limité à 1/niveau)\n")
                elif str(grille).count("5")>1:
                    print("Trop de clef 5 (limité à 1/niveau)\n")
                elif "5" in str(grille) and not "6" in str(grille):
                    print("Clef 5 sans bloc pour elle\n")
                elif not "8" in str(grille):
                    print("Il n'y a pas de fin 8 !\n")
                elif not "9" in str(grille):
                    print("Il n'y a pas de début 9 !\n")
                elif str(grille).count("8")>1:
                    print("Il ne peut y avoir qu'une seule fin 8")
                elif str(grille).count("9")>1:
                    print("Il ne peut y avoir qu'un seul début 9 !")
                else:
                    print(str(grille).replace("], ","]").replace("(","[").replace(")","]").replace("'","")+"→Mat A"+"\n")
            if event.button == 3:
                x=int(event.pos[0]/52)
                y=int(event.pos[1]/52)
                for i in range(len(suite)):
                    if grille[y][x] == suite[i]:
                        if i!=len(suite)+1:
                            grille[y][x]=suite[i-1]
                            break
                        else:
                            grille[y][x]=suite[len(suite)]
                            break
                pygame.draw.rect(fenetre,(255,255,255),((52*x, 52*y), (55, 55)))
                place()